#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum NumberFormatDisplayOption {
    #[serde(rename = "SCIENTIFIC")]
    Scientific,
    #[serde(rename = "SUCCINCT")]
    Succinct,
    #[serde(rename = "LOCALE")]
    Locale,
    #[serde(rename = "PLAIN")]
    Plain,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl NumberFormatDisplayOption {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            NumberFormatDisplayOption::Scientific => "SCIENTIFIC",
            NumberFormatDisplayOption::Succinct => "SUCCINCT",
            NumberFormatDisplayOption::Locale => "LOCALE",
            NumberFormatDisplayOption::Plain => "PLAIN",
            NumberFormatDisplayOption::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for NumberFormatDisplayOption {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for NumberFormatDisplayOption {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for NumberFormatDisplayOption {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<NumberFormatDisplayOption, conjure_object::plain::ParseEnumError> {
        match v {
            "SCIENTIFIC" => Ok(NumberFormatDisplayOption::Scientific),
            "SUCCINCT" => Ok(NumberFormatDisplayOption::Succinct),
            "LOCALE" => Ok(NumberFormatDisplayOption::Locale),
            "PLAIN" => Ok(NumberFormatDisplayOption::Plain),
            v => v.parse().map(|v| NumberFormatDisplayOption::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for NumberFormatDisplayOption {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<NumberFormatDisplayOption, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the NumberFormatDisplayOption enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
